Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgraro2_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgraro2_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/nxgraro2_loc.F	(revision 4727)
@@ -20,7 +20,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comdissipn.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comdissipn.h"
 c
 c    ......  variables en arguments  .......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/parallel_lmdz.F90	(revision 4727)
@@ -4,4 +4,5 @@
   MODULE parallel_lmdz
   USE mod_const_mpi
+  USE lmdz_mpi, ONLY : using_mpi
 #ifdef CPP_IOIPSL
       use IOIPSL
@@ -12,5 +13,4 @@
     INTEGER,PARAMETER :: halo_max=3
     
-    LOGICAL,SAVE :: using_mpi ! .true. if using MPI
     LOGICAL,SAVE :: using_omp ! .true. if using OpenMP
     LOGICAL,SAVE :: is_master ! .true. if the core is both MPI & OpenMP master
@@ -88,11 +88,9 @@
     subroutine init_parallel
     USE vampir
+    USE lmdz_mpi
     implicit none
-#ifdef CPP_MPI
-      include 'mpif.h'
-#endif
-#include "dimensions.h"
-#include "paramet.h"
-#include "iniprint.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "iniprint.h"
 
       integer :: ierr
@@ -111,11 +109,4 @@
 #endif  
 
-#ifdef CPP_MPI
-       using_mpi=.TRUE.
-#else
-       using_mpi=.FALSE.
-#endif
-      
-
 #ifdef CPP_OMP
        using_OMP=.TRUE.
@@ -127,8 +118,6 @@
       
       IF (using_mpi) THEN
-#ifdef CPP_MPI
         call MPI_COMM_SIZE(COMM_LMDZ,mpi_size,ierr)
         call MPI_COMM_RANK(COMM_LMDZ,mpi_rank,ierr)
-#endif
       ELSE
         mpi_size=1
@@ -161,7 +150,6 @@
          write(lunout,*)" ---> diminuez le nombre de CPU ou augmentez la taille en lattitude"
           
-#ifdef CPP_MPI
           IF (using_mpi) call MPI_ABORT(COMM_LMDZ,-1, ierr)
-#endif          
+
         endif
         
@@ -395,8 +383,8 @@
     
     subroutine Finalize_parallel
-#ifdef CPP_XIOS
+    USE lmdz_mpi
     ! ug Pour les sorties XIOS
-	USE wxios
-#endif
+  	USE wxios
+
 #ifdef CPP_COUPLE
 ! Use of Oasis-MCT coupler 
@@ -418,7 +406,4 @@
       include "dimensions.h"
       include "paramet.h"
-#ifdef CPP_MPI
-      include 'mpif.h'
-#endif      
 
       integer :: ierr
@@ -430,23 +415,21 @@
 
       if (type_ocean == 'couple') then
-#ifdef CPP_XIOS
-    !Fermeture propre de XIOS
-      CALL wxios_close()
-#else
+        IF (using_xios) THEN
+          !Fermeture propre de XIOS
+          CALL wxios_close()
+        ELSE
 #ifdef CPP_COUPLE
-         call prism_terminate_proto(ierr)
-         IF (ierr .ne. PRISM_Ok) THEN
-            call abort_gcm('Finalize_parallel',' Probleme dans prism_terminate_proto ',1)
-         endif
+           call prism_terminate_proto(ierr)
+           IF (ierr .ne. PRISM_Ok) THEN
+              call abort_gcm('Finalize_parallel',' Probleme dans prism_terminate_proto ',1)
+           endif
 #endif 
-#endif
+        ENDIF
       else
-#ifdef CPP_XIOS
-    !Fermeture propre de XIOS
-      CALL wxios_close()
-#endif
-#ifdef CPP_MPI
-         IF (using_mpi) call MPI_FINALIZE(ierr)
-#endif
+        IF (using_xios) THEN
+          !Fermeture propre de XIOS
+          CALL wxios_close()
+        ENDIF
+        IF (using_mpi) call MPI_FINALIZE(ierr)
       end if
       
@@ -456,6 +439,6 @@
     implicit none
 
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 
       integer, intent(in) :: ij,ll,row
@@ -479,6 +462,6 @@
     implicit none
 
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 
       integer, intent(in) :: ij,ll,row
@@ -502,14 +485,10 @@
     
     SUBROUTINE barrier
+    USE lmdz_mpi
     IMPLICIT NONE
-#ifdef CPP_MPI
-    INCLUDE 'mpif.h'
-#endif
     INTEGER :: ierr
     
 !$OMP CRITICAL (MPI)      
-#ifdef CPP_MPI
       IF (using_mpi) CALL MPI_Barrier(COMM_LMDZ,ierr)
-#endif
 !$OMP END CRITICAL (MPI)
     
@@ -518,11 +497,9 @@
       
     subroutine exchange_hallo(Field,ij,ll,up,down)
+    USE lmdz_mpi
     USE Vampir
     implicit none
-#include "dimensions.h"
-#include "paramet.h"    
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -533,9 +510,6 @@
       LOGICAL :: RecvUp,RecvDown
       INTEGER, DIMENSION(4) :: Request
-#ifdef CPP_MPI
       INTEGER, DIMENSION(MPI_STATUS_SIZE,4) :: Status
-#else
-      INTEGER, DIMENSION(1,4) :: Status
-#endif
+
       INTEGER :: NbRequest
       REAL, dimension(:),allocatable :: Buffer_Send_up,Buffer_Send_down
@@ -582,8 +556,6 @@
           call PACK_Data(Field(ij_begin,1),ij,ll,down,Buffer_Send_up)
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
           call MPI_ISEND(Buffer_send_up,Buffer_Size,MPI_REAL8,MPI_Rank-1,1,     &
                           COMM_LMDZ,Request(NbRequest),ierr)
-#endif
 !$OMP END CRITICAL (MPI)
         ENDIF
@@ -597,8 +569,6 @@
         
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
           call MPI_ISEND(Buffer_send_down,Buffer_Size,MPI_REAL8,MPI_Rank+1,1,     &
                           COMM_LMDZ,Request(NbRequest),ierr)
-#endif
 !$OMP END CRITICAL (MPI)
         ENDIF
@@ -611,8 +581,6 @@
               
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
           call MPI_IRECV(Buffer_recv_up,Buffer_size,MPI_REAL8,MPI_Rank-1,1,  &
                           COMM_LMDZ,Request(NbRequest),ierr)
-#endif
 !$OMP END CRITICAL (MPI)
      
@@ -626,15 +594,11 @@
         
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
           call MPI_IRECV(Buffer_recv_down,Buffer_size,MPI_REAL8,MPI_Rank+1,1,     &
                           COMM_LMDZ,Request(NbRequest),ierr)
-#endif
 !$OMP END CRITICAL (MPI)
         
         ENDIF
   
-#ifdef CPP_MPI
         if (NbRequest > 0) call MPI_WAITALL(NbRequest,Request,Status,ierr)
-#endif
         IF (RecvUp)  call Unpack_Data(Field(ij_begin-up*iip1,1),ij,ll,up,Buffer_Recv_up)
         IF (RecvDown) call Unpack_Data(Field(ij_end+1,1),ij,ll,down,Buffer_Recv_down)  
@@ -651,11 +615,9 @@
 
     subroutine Gather_Field(Field,ij,ll,rank)
+    USE lmdz_mpi
     implicit none
-#include "dimensions.h"
-#include "paramet.h" 
-#include "iniprint.h"
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
+    INCLUDE "dimensions.h"
+    INCLUDE "paramet.h" 
+    INCLUDE "iniprint.h"
       INTEGER :: ij,ll,rank
       REAL, dimension(ij,ll) :: Field
@@ -709,8 +671,6 @@
   
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
         call MPI_GATHERV(Buffer_send,(min(ij_end,ij)-ij_begin+1)*ll,MPI_REAL8,   &
                           Buffer_Recv,Recv_count,displ,MPI_REAL8,rank,COMM_LMDZ,ierr)
-#endif
 !$OMP END CRITICAL (MPI)
       
@@ -735,10 +695,8 @@
 
     subroutine AllGather_Field(Field,ij,ll)
+    USE lmdz_mpi
     implicit none
-#include "dimensions.h"
-#include "paramet.h"    
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
+    INCLUDE "dimensions.h"
+    INCLUDE "paramet.h"    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -748,7 +706,5 @@
         call Gather_Field(Field,ij,ll,0)
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
       call MPI_BCAST(Field,ij*ll,MPI_REAL8,0,COMM_LMDZ,ierr)
-#endif
 !$OMP END CRITICAL (MPI)
       ENDIF
@@ -757,10 +713,8 @@
     
    subroutine Broadcast_Field(Field,ij,ll,rank)
+    USE lmdz_mpi
     implicit none
-#include "dimensions.h"
-#include "paramet.h"    
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif    
+    INCLUDE "dimensions.h"
+    INCLUDE "paramet.h"    
       INTEGER :: ij,ll
       REAL, dimension(ij,ll) :: Field
@@ -771,7 +725,5 @@
       
 !$OMP CRITICAL (MPI)
-#ifdef CPP_MPI
       call MPI_BCAST(Field,ij*ll,MPI_REAL8,rank,COMM_LMDZ,ierr)
-#endif
 !$OMP END CRITICAL (MPI)
       
@@ -781,8 +733,8 @@
    
 !  Subroutine verif_hallo(Field,ij,ll,up,down)
+!    USE lmdz_mpi
 !    implicit none
-!#include "dimensions.h"
-!#include "paramet.h"    
-!    include 'mpif.h'
+!      INCLUDE "dimensions.h"
+!      INCLUDE "paramet.h"    
 !    
 !      INTEGER :: ij,ll
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/pression_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/pression_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/pression_loc.F	(revision 4727)
@@ -14,6 +14,6 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
 c
       INTEGER,INTENT(IN) :: ngrid ! not used
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_nfil_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_nfil_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_nfil_loc.F	(revision 4727)
@@ -13,7 +13,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c   .....  variables en arguments  ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_p.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_p.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotat_p.F	(revision 4727)
@@ -13,7 +13,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c   .....  variables en arguments  ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotatf_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotatf_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/rotatf_loc.F	(revision 4727)
@@ -14,7 +14,7 @@
       IMPLICIT NONE
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "comgeom.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "comgeom.h"
 c
 c   .....  variables en arguments  ......
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/temps_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/temps_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/temps_mod.F90	(revision 4727)
@@ -19,4 +19,5 @@
   REAL      start_time
   CHARACTER (len=10) :: calend ! calendar type
+  INTEGER   offline_time ! offline frequency storage
 
   ! Additionnal Mars stuff:
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/times.F90	(revision 4727)
@@ -27,6 +27,6 @@
     USE parallel_lmdz
     implicit none
-#include "dimensions.h"
-#include "paramet.h"
+    INCLUDE "dimensions.h"
+    INCLUDE "paramet.h"
     
     max_size=jjm+1
@@ -137,8 +137,7 @@
   subroutine allgather_timer
     USE parallel_lmdz
-    implicit none
-#ifdef CPP_MPI    
-    include 'mpif.h'
-#endif
+    USE lmdz_mpi
+    implicit none
+
     integer :: ierr
     integer :: data_size
@@ -155,11 +154,7 @@
     
       tmp_table(:,:)=timer_table(:,:,mpi_rank)
-#ifdef CPP_MPI 
       call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_table(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
-#endif
       tmp_table(:,:)=timer_table_sqr(:,:,mpi_rank)
-#ifdef CPP_MPI
       call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_table_sqr(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
-#endif    
       deallocate(tmp_table)
     
@@ -172,8 +167,6 @@
   subroutine allgather_timer_average
     USE parallel_lmdz
-    implicit none
-#ifdef CPP_MPI
-    include 'mpif.h'
-#endif
+    USE lmdz_mpi
+    implicit none
     integer :: ierr
     integer :: data_size
@@ -192,15 +185,9 @@
 
       tmp_table(:,:)=timer_average(:,:,mpi_rank)
-#ifdef CPP_MPI
       call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_average(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
-#endif
       tmp_table(:,:)=timer_delta(:,:,mpi_rank)
-#ifdef CPP_MPI
       call mpi_allgather(tmp_table(1,1),data_size,MPI_REAL_LMDZ,timer_delta(1,1,0),data_size,MPI_REAL_LMDZ,COMM_LMDZ,ierr)
-#endif
       tmp_iter(:,:)=timer_iteration(:,:,mpi_rank)
-#ifdef CPP_MPI
       call mpi_allgather(tmp_iter(1,1),data_size,MPI_INTEGER,timer_iteration(1,1,0),data_size,MPI_INTEGER,COMM_LMDZ,ierr)
-#endif    
       deallocate(tmp_table)
     
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/top_bound_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/top_bound_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/top_bound_loc.F	(revision 4727)
@@ -54,6 +54,6 @@
 
 
-#include "comdissipn.h"
-#include "iniprint.h"
+      INCLUDE "comdissipn.h"
+      INCLUDE "iniprint.h"
 
 c   Arguments:
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/vlsplt_loc.F	(revision 4727)
@@ -1207,6 +1207,6 @@
 c      SUBROUTINE minmaxq(zq,qmin,qmax,comment)
 c
-c#include "dimensions.h"
-c#include "paramet.h"
+c      INCLUDE "dimensions.h"
+c      INCLUDE "paramet.h"
 
 c      CHARACTER*(*) comment
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/wrgrads.F	(revision 4727)
@@ -12,5 +12,5 @@
 c    titlevar   Titre
 
-#include "gradsdef.h"
+      INCLUDE "gradsdef.h"
 
 c   arguments
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/writedyn_xios.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/writedyn_xios.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dyn3dmem/writedyn_xios.F90	(revision 4727)
@@ -5,6 +5,5 @@
      &                           masse,ps,phis)
 
-#ifdef CPP_XIOS
-      USE xios
+      USE lmdz_xios
       USE parallel_lmdz
       USE misc_mod
@@ -180,5 +179,3 @@
       CALL writefield_dyn_u('PS', ps(ijb:ije))
 
-#endif
-
       END
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/calfis_loc.F	(revision 4727)
@@ -38,4 +38,6 @@
       USE IOPHY
 #endif
+      USE lmdz_mpi
+
 #ifdef CPP_PARA
       USE parallel_lmdz,ONLY:omp_chunk,using_mpi,jjb_u,jje_u,jjb_v,jje_v
@@ -117,7 +119,4 @@
       include "comgeom2.h"
       include "iniprint.h"
-#ifdef CPP_MPI
-      include 'mpif.h'
-#endif
 c    Arguments :
 c    -----------
@@ -233,9 +232,5 @@
       REAL,SAVE,dimension(1:iim,1:llm):: du_send,du_recv,dv_send,dv_recv
       INTEGER :: ierr
-#ifdef CPP_MPI
       INTEGER,dimension(MPI_STATUS_SIZE,4) :: Status
-#else
-      INTEGER,dimension(1,4) :: Status
-#endif
       INTEGER, dimension(4) :: Req
       REAL,ALLOCATABLE,SAVE:: zdufi2(:,:),zdvfi2(:,:)
@@ -873,5 +868,5 @@
 
 c$OMP BARRIER
-#ifdef CPP_MPI 
+
 c$OMP MASTER
 !$OMP CRITICAL (MPI)
@@ -882,5 +877,5 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
-#endif
+
 c$OMP BARRIER
      
@@ -889,5 +884,5 @@
       if (MPI_rank<MPI_Size-1) then
 c$OMP BARRIER
-#ifdef CPP_MPI 
+
 c$OMP MASTER      
 !$OMP CRITICAL (MPI)
@@ -898,5 +893,5 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
-#endif
+
       endif
 
@@ -904,5 +899,4 @@
 
 
-#ifdef CPP_MPI 
 c$OMP MASTER    
 !$OMP CRITICAL (MPI)
@@ -916,5 +910,4 @@
 !$OMP END CRITICAL (MPI)
 c$OMP END MASTER
-#endif
 
 c$OMP BARRIER     
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 4727)
@@ -22,8 +22,5 @@
   USE control_mod, ONLY: planet_type, ok_dyn_xios
   USE physiq_mod, ONLY: physiq
-#ifdef CPP_XIOS
-  USE mod_xios_dyn3dmem, ONLY : dyn3d_ctx_handle
-  USE xios, ONLY : xios_set_current_context
-#endif
+  USE lmdz_xios, ONLY : xios_set_current_context, xios_get_current_context, xios_context
   IMPLICIT NONE
 
@@ -56,5 +53,6 @@
   REAL,INTENT(OUT) :: zdqfi_omp(klon,llm,nqtot) ! tendency on tracers
   REAL,INTENT(OUT) :: zdpsrf_omp(klon) ! tendency on surface pressure
-  
+  TYPE(xios_context) :: dyn3d_ctx_handle
+
   ! Local variables
   CHARACTER(len=11) :: modname="call_physiq"
@@ -70,4 +68,9 @@
   ENDIF
 
+  !$OMP MASTER
+  if (ok_dyn_xios) then
+     CALL xios_get_current_context(dyn3d_ctx_handle)
+  endif
+  !$OMP END MASTER
 
 ! Call physics package with required inputs/outputs
@@ -95,5 +98,4 @@
 
 ! switching back to LMDZDYN context
-#ifdef CPP_XIOS
 !$OMP MASTER
   if (ok_dyn_xios) then
@@ -101,5 +103,4 @@
   endif
 !$OMP END MASTER
-#endif  
 
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/ce0l.F90	(revision 4727)
@@ -36,7 +36,5 @@
   USE mod_hallo,      ONLY: init_mod_hallo
   USE mod_interface_dyn_phys, ONLY: init_interface_dyn_phys
-#ifdef CPP_XIOS
-  USE xios, only: xios_finalize
-#endif
+  USE lmdz_xios, only: using_xios, xios_finalize
 #endif
 
@@ -46,4 +44,5 @@
   USE comvert_mod, ONLY: pa, preff, pressure_exner
   USE temps_mod, ONLY: calend, day_ini, dt
+  USE lmdz_mpi
 
   IMPLICIT NONE
@@ -55,7 +54,4 @@
   include "comgeom2.h"
   include "iniprint.h"
-#ifdef CPP_MPI
-  include 'mpif.h'
-#endif
   
   REAL               :: masque(iip1,jjp1)             !--- CONTINENTAL MASK
@@ -252,10 +248,6 @@
 #ifdef CPP_PARA
   END IF
-#ifdef CPP_XIOS
-  CALL xios_finalize
-#endif
-#ifdef CPP_MPI
+  IF (using_xios) CALL xios_finalize
   IF (using_mpi) call MPI_FINALIZE(ierr)
-#endif
 #endif
 
Index: /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/dynphy_lonlat/phylmd/etat0phys_netcdf.F90	(revision 4727)
@@ -94,5 +94,5 @@
   USE init_ssrf_m, ONLY: start_init_subsurf
   USE phys_state_var_mod, ONLY: beta_aridity, delta_tsurf, awake_dens, cv_gen, &
-       ratqs_inter, rneb_ancien
+       ratqs_inter_, rneb_ancien
   !use ioipsl_getincom
   IMPLICIT NONE
@@ -143,5 +143,5 @@
                    fact_cldcon, facttemps,ok_newmicro,iflag_radia,      &
                    iflag_cldcon,                                        &
-                   iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs,            &
+                   ratqsbas,ratqshaut,tau_ratqs,            &
                    ok_ade, ok_aie, ok_alw, ok_cdnc, ok_volcan, flag_volc_surfstrat,     &
                    aerosol_couple, chemistry_couple, flag_aerosol, flag_aerosol_strat,  & 
@@ -285,5 +285,5 @@
   end IF
 
-  ratqs_inter = 0.002
+  ratqs_inter_ = 0.002
   rneb_ancien = 0.
   CALL phyredem( "startphy.nc" )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/eigen.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/eigen.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/eigen.F	(revision 4727)
@@ -4,5 +4,5 @@
       SUBROUTINE eigen( e,d)
       IMPLICIT NONE
-#include "dimensions.h"
+      INCLUDE "dimensions.h"
       real :: e( iim,iim ), d( iim )
       real :: asm( iim )
Index: /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg.F	(revision 4727)
@@ -46,7 +46,7 @@
 c
 c
-#include "dimensions.h"
-#include "paramet.h"
-#include "coefils.h"
+      INCLUDE "dimensions.h"
+      INCLUDE "paramet.h"
+      INCLUDE "coefils.h"
 
       INTEGER    nlat,nbniv,ifiltre,iter
Index: /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/filtrez/filtreg_mod.F90	(revision 4727)
@@ -16,4 +16,6 @@
   USE serre_mod, ONLY: alphax
   USE logic_mod, ONLY: fxyhypb, ysinus
+  USE comconst_mod, ONLY: maxlatfilter
+
     !    ... H. Upadhyaya, O.Sharma   ...
     !
@@ -125,4 +127,8 @@
     ! as length dx becomes of the same size as dy 
     !
+    ! if maxlatfilter >0, prescribe the colat0 value from the .def files
+   
+    IF (maxlatfilter .LT. 0.) THEN
+
     colat0  =  MIN( 0.5, dymin/dxmin )
     ! colat0  =  1.
@@ -133,4 +139,13 @@
        alphax = 0.
     ENDIF
+
+    ELSE
+
+    colat0=(90.0-maxlatfilter)/180.0*pi        
+
+    ENDIF
+    
+    
+    
     !
     PRINT 50, colat0,alphax
Index: /LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim	(revision 4726)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/grid/dimension/makdim	(revision 4727)
@@ -12,5 +12,5 @@
 fi
 
-if ( ( ($1 % 8 != 0)) && (( $# == 3 ) ) || ( $1 == 1 ) )
+if ( (( $1 % 8 != 0 )) && (( $# == 3 )) || (( $1 == 1 )) )
 then
     echo "The number of longitudes must be a multiple of 8."
Index: /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi.F90	(revision 4727)
@@ -0,0 +1,27 @@
+#ifdef CPP_MPI
+MODULE lmdz_mpi
+
+  INCLUDE 'mpif.h'
+  LOGICAL,PARAMETER :: using_mpi = .TRUE.
+END MODULE lmdz_mpi
+
+#else
+
+MODULE lmdz_mpi
+  LOGICAL,PARAMETER :: using_mpi = .FALSE.
+
+  INTEGER, PARAMETER         :: MPI_REAL8 = 1
+  INTEGER, PARAMETER         :: MPI_INTEGER = 1
+  INTEGER, PARAMETER         :: MPI_CHARACTER = 1
+  INTEGER, PARAMETER         :: MPI_LOGICAL = 1
+  INTEGER, PARAMETER         :: MPI_SUM = 1
+  INTEGER, PARAMETER         :: MPI_MIN = 1
+  INTEGER, PARAMETER         :: MPI_COMM_WORLD = 1
+  INTEGER, PARAMETER         :: MPI_STATUS_SIZE = 1
+  INTEGER, PARAMETER         :: MPI_THREAD_SERIALIZED =1
+  INTEGER(kind=8), PARAMETER :: MPI_ADDRESS_KIND = 1
+  INTEGER, PARAMETER         :: MPI_INFO_NULL = 1
+
+END MODULE lmdz_mpi
+
+#endif
Index: /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi_wrappers.F90
===================================================================
--- /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi_wrappers.F90	(revision 4727)
+++ /LMDZ6/branches/LMDZ_ECRad/libf/misc/lmdz_mpi_wrappers.F90	(revision 4727)
@@ -0,0 +1,172 @@
+! mpi subroutine wrappers
+
+#ifndef CPP_MPI
+
+SUBROUTINE lmdz_mpi_wrapper_abort
+  STOP 'CPP_MPI key undefined, must not enter in MPI wrappers ==> aborting'
+END SUBROUTINE lmdz_mpi_wrapper_abort
+
+SUBROUTINE MPI_ABORT(COMM, ERRORCODE, IERROR)
+IMPLICIT NONE
+    INTEGER ::       COMM, ERRORCODE, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_ABORT
+
+SUBROUTINE MPI_ALLGATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::   SENDBUF , RECVBUF
+    INTEGER    SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, COMM
+    INTEGER    IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE   MPI_ALLGATHER
+  
+SUBROUTINE MPI_COMM_SIZE(COMM, SIZE, IERROR)
+IMPLICIT NONE
+    INTEGER    COMM, SIZE, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_COMM_SIZE
+
+SUBROUTINE MPI_COMM_RANK(COMM, RANK, IERROR)
+IMPLICIT NONE
+    INTEGER    COMM, RANK, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_COMM_RANK
+
+SUBROUTINE MPI_BARRIER(COMM, IERROR)
+IMPLICIT NONE
+    INTEGER    COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_BARRIER   
+
+SUBROUTINE MPI_ISEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    BUF
+    INTEGER    COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR
+    
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_ISEND
+
+SUBROUTINE MPI_ISSEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    BUF
+    INTEGER    COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_ISSEND
+
+SUBROUTINE MPI_IRECV(BUF, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    BUF
+    INTEGER    COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_IRECV   
+
+SUBROUTINE MPI_WAITALL(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES, IERROR)
+USE lmdz_mpi, ONLY : MPI_STATUS_SIZE
+IMPLICIT NONE
+    INTEGER    COUNT, ARRAY_OF_REQUESTS(*)
+    INTEGER    ARRAY_OF_STATUSES(MPI_STATUS_SIZE,*), IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE  MPI_WAITALL  
+
+SUBROUTINE MPI_GATHERV(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    SENDBUF, RECVBUF
+    INTEGER    SENDCOUNT, SENDTYPE, RECVCOUNTS(*), DISPLS(*)
+    INTEGER    RECVTYPE, ROOT, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_GATHERV
+    
+SUBROUTINE MPI_BCAST(BUFFER, COUNT, DATATYPE, ROOT, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    BUFFER
+    INTEGER    COUNT, DATATYPE, ROOT, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_BCAST
+
+SUBROUTINE MPI_ALLREDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    SENDBUF, RECVBUF
+    INTEGER    COUNT, DATATYPE, OP, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_ALLREDUCE
+
+SUBROUTINE MPI_INIT_THREAD(REQUIRED, PROVIDED, IERROR)
+IMPLICIT NONE
+    INTEGER    REQUIRED, PROVIDED, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_INIT_THREAD
+
+SUBROUTINE MPI_ALLOC_MEM(SIZE, INFO, BASEPTR, IERROR)
+USE lmdz_mpi, ONLY : MPI_ADDRESS_KIND
+IMPLICIT NONE
+    INTEGER INFO, IERROR
+    INTEGER(KIND=MPI_ADDRESS_KIND) SIZE, BASEPTR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_ALLOC_MEM
+
+SUBROUTINE MPI_SCATTERV(SENDBUF, SENDCOUNTS, DISPLS, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::    SENDBUF, RECVBUF
+    INTEGER    SENDCOUNTS(*), DISPLS(*), SENDTYPE
+    INTEGER    RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_SCATTERV
+
+SUBROUTINE MPI_REDUCE(SENDBUF, RECVBUF, COUNT, DATATYPE, OP, ROOT, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE ::    SENDBUF, RECVBUF
+    INTEGER    COUNT, DATATYPE, OP, ROOT, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_REDUCE
+
+SUBROUTINE MPI_RECV(BUF, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)
+USE ISO_C_BINDING
+USE lmdz_mpi, ONLY : MPI_STATUS_SIZE
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE ::    BUF
+    INTEGER    COUNT, DATATYPE, SOURCE, TAG, COMM
+    INTEGER    STATUS(MPI_STATUS_SIZE), IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_RECV
+
+SUBROUTINE MPI_SEND(BUF, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::  BUF
+    INTEGER    COUNT, DATATYPE, DEST, TAG, COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_SEND
+
+SUBROUTINE MPI_COMM_SPLIT(COMM, COLOR, KEY, NEWCOMM, IERROR)
+IMPLICIT NONE
+    INTEGER    COMM, COLOR, KEY, NEWCOMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_COMM_SPLIT
+
+
+SUBROUTINE MPI_GATHER(SENDBUF, SENDCOUNT, SENDTYPE, RECVBUF, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
+USE ISO_C_BINDING
+IMPLICIT NONE
+    TYPE(C_PTR),VALUE  ::  SENDBUF, RECVBUF
+    INTEGER    SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, ROOT
+    INTEGER    COMM, IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_GATHER
+
+
+SUBROUTINE MPI_FINALIZE(IERROR)
+IMPLICIT NONE
+    INTEGER    IERROR
+    CALL lmdz_mpi_wrapper_abort
+END SUBROUTINE MPI_Finalize
+
+#endif
